/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.tarifas;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.MercadoCompetido;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.ParadaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderMercadoCompetido;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Paging;

/**
 *
 * @author rodrigo
 */
@Controller("busquedaMercadoCompetidoController")
@Scope("prototype")
public class BusquedaMercadoCompetidoController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<MercadoCompetido> plwMercadoCompetido;
    @Autowired
    private ClaseServicioService claseServicioService;
    @Autowired
    private ParadaService paradaService;
    private List<ClaseServicio> lsClaseServicio;
    private Combobox cmbClaseServicio;
    private Combobox cmbOrigem;
    private Combobox cmbDestino;
    private MyListbox mercadoCompetidoList;
    private Paging pagingMercadoCompetido;

    public List<ClaseServicio> getLsClaseServicio() {
        return lsClaseServicio;
    }

    public void setLsClaseServicio(List<ClaseServicio> lsClaseServicio) {
        this.lsClaseServicio = lsClaseServicio;
    }

    public Paging getPagingMercadoCompetido() {
        return pagingMercadoCompetido;
    }

    public void setPagingMercadoCompetido(Paging pagingMercadoCompetido) {
        this.pagingMercadoCompetido = pagingMercadoCompetido;
    }

    public Combobox getCmbClaseServicio() {
        return cmbClaseServicio;
    }

    public void setCmbClaseServicio(Combobox cmbClaseServicio) {
        this.cmbClaseServicio = cmbClaseServicio;
    }

    public Combobox getCmbDestino() {
        return cmbDestino;
    }

    public void setCmbDestino(Combobox cmbDestino) {
        this.cmbDestino = cmbDestino;
    }

    public Combobox getCmbOrigem() {
        return cmbOrigem;
    }

    public void setCmbOrigem(Combobox cmbOrigem) {
        this.cmbOrigem = cmbOrigem;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verMercadoCompetido(new MercadoCompetido());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        mercadoCompetidoList.setItemRenderer(new RenderMercadoCompetido());
        mercadoCompetidoList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                MercadoCompetido mc = (MercadoCompetido) mercadoCompetidoList.getSelected();
                verMercadoCompetido(mc);
            }
        });

        lsClaseServicio = claseServicioService.obtenerTodos();

        //Leticia- Nao pode ter opção TODOS
        Short menosUm = -1;
        ClaseServicio cs = claseServicioService.obtenerID((int)menosUm);
        if (cs != null) {
            lsClaseServicio.remove(cs);
        }


        refreshLista();
    }

    private void verMercadoCompetido(MercadoCompetido mc) {
        if (mc == null) {
            return;
        }

        Map args = new HashMap();
        args.put("mercadoCompetido", mc);
        args.put("mercadoCompetidoList", mercadoCompetidoList);

        openWindow("/gui/tarifas/editarMercadoCompetido.zul",
                Labels.getLabel("editarMercadoCompetidoController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<MercadoCompetido> tarifaBusqueda =
                new HibernateSearchObject<MercadoCompetido>(MercadoCompetido.class, pagingMercadoCompetido.getPageSize());
        tarifaBusqueda.addFilterEqual("activo", Boolean.TRUE);

        ClaseServicio claseServicio = (ClaseServicio) (cmbClaseServicio.getSelectedItem() != null ? cmbClaseServicio.getSelectedItem().getValue() : null);
        Parada origem = (Parada) (cmbOrigem.getSelectedItem() != null ? cmbOrigem.getSelectedItem().getValue() : null);
        Parada destino = (Parada) (cmbDestino.getSelectedItem() != null ? cmbDestino.getSelectedItem().getValue() : null);

        tarifaBusqueda.addFilterEqual("origem", origem);
        tarifaBusqueda.addFilterEqual("destino", destino);
        tarifaBusqueda.addFilterEqual("claseServicio", claseServicio);

        tarifaBusqueda.addSortAsc("claseServicio.descclase");

        plwMercadoCompetido.init(tarifaBusqueda, mercadoCompetidoList, pagingMercadoCompetido);

        if (mercadoCompetidoList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaMercadoCompetidoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

   
}
